ArcRepair = LibStub("AceAddon-3.0"):NewAddon("ArcRepair", "AceEvent-3.0", "AceConsole-3.0")

local options = {
	name = "ArcRepair",
	handler = ArcRepair,
	type = "group",
	args = {
		Sunday = {
			type = "toggle",
			name = "Sunday",
			desc = "Toggles Guild Repairs on Sunday",
			get = "GetDayEnabled",
			set = "ToggleDay"
		},
		Monday = {
			type = "toggle",
			name = "Monday",
			desc = "Toggles Guild Repairs on Monday",
			get = "GetDayEnabled",
			set = "ToggleDay"
		},
		Tuesday = {
			type = "toggle",
			name = "Tuesday",
			desc = "Toggles Guild Repairs on Tuesday",
			get = "GetDayEnabled",
			set = "ToggleDay"
		},
		Wednesday = {
			type = "toggle",
			name = "Wednesday",
			desc = "Toggles Guild Repairs on Wednesday",
			get = "GetDayEnabled",
			set = "ToggleDay"
		},
		Thursday = {
			type = "toggle",
			name = "Thursday",
			desc = "Toggles Guild Repairs on Thursday",
			get = "GetDayEnabled",
			set = "ToggleDay"
		},
		Friday = {
			type = "toggle",
			name = "Friday",
			desc = "Toggles Guild Repairs on Friday",
			get = "GetDayEnabled",
			set = "ToggleDay"
		},
		Saturday = {
			type = "toggle",
			name = "Saturday",
			desc = "Toggles Guild Repairs on Saturday",
			get = "GetDayEnabled",
			set = "ToggleDay"
		},
	},
}

local defaults = {
	profile = {
		Sunday = true,
		Monday = false,
		Tuesday = true,
		Wednesday = true,
		Thursday = false,
		Friday = false,
		Saturday = false,
	}
}

local days = {
	"Sunday",
	"Monday",
	"Tuesday",
	"Wednesday",
	"Thursday",
	"Friday",
	"Saturday"
}

function ArcRepair:OnEnable()
	self:RegisterEvent("MERCHANT_SHOW", "RepairItems")
end

function ArcRepair:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("ArcRepairSaved", defaults)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("ArcRepair", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("ArcRepair", "ArcRepair")
	self:RegisterChatCommand("arcrepair", "ChatCommand")
	self:RegisterChatCommand("ar", "ChatCommand")
end

function ArcRepair:RepairItems()
	if(CanMerchantRepair()) then
		local cost, canRepair = GetRepairAllCost()
		local grepair = CanGuildBankRepair()
		local day = CalendarGetDate()
		
		if(grepair) then
			self:Print(days[day])
			if(self.db.profile[days[day]]) then
				grepair = true
			else
				grepair = false
			end
		end
		
		if(canRepair) then
			RepairAllItems(grepair)
			
			if(grepair) then
				repairmessage = "Repaired from Guild Bank for: "
			else
				repairmessage = "Repaired from your wallet for: "
			end
			
			self:Print(repairmessage..GetCoinTextureString(cost))
			self.db.profile.day[1] = false
		end
	end
end

function ArcRepair:ToggleDay(info, value)
	self:Print(info[#info].." - "..tostring(value))
	if(self.db.profile[info[#info]]) then
		self.db.profile[info[#info]] = false
	else
		self.db.profile[info[#info]] = true
	end
end

function ArcRepair:GetDayEnabled(info)
	return self.db.profile[info[#info]]
end

function ArcRepair:ChatCommand(input)
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(ArcRepair, "ar", "arcrepair", input)
	end
end